package main

import "net"

type AbstractBridge struct {
	ExistingInterface string
	BridgeIpCIDR      string
	hIerarchyNumber   string
	GArp              *Gratuitous
}

type AbstractMulticast struct {
	MIpAddr         string
	MPort           string
	MaxDatagramSize int
	MWaddr          *net.UDPAddr
	MRaddr          *net.UDPAddr
	Wconn           *net.UDPConn
	Rconn           *net.UDPConn
	HierarchyArray  []string
}

type AbstractConfig struct {
	MulticastConfig struct {
		MIPAddr         string `json:"MIpAddr"`
		MPort           string `json:"MPort"`
		MaxDatagramSize int    `json:"MaxDatagramSize"`
	} `json:"MulticastConfig"`
	InterfaceConfig struct {
		ExistingInterface string `json:"ExistingInterface"`
		BridgeIPCIDR      string `json:"BridgeIpCIDR"`
	} `json:"InterfaceConfig"`
	Debug bool `json:"debug"`
}
